#include "stdafx.h"
#include "Ts1segFilter.h"

CTs1segFilter::CTs1segFilter(IEventHandler *pEventHandler)
#if USE_TSANALYZER
	: CTsAnalyzer(pEventHandler)
#else
	: CMediaDecoder(pEventHandler, 1, 1)
#endif
{
	this->Reset();
#if USE_STATICPASS
//	this->m_wStaticPassTable.insert( 0x0000 );	// PAT(ZOł͕sv)
//	this->m_wStaticPassTable.insert( 0x0001 );	// CAT
	this->m_wStaticPassTable.insert( 0x0010 );	// NIT
	this->m_wStaticPassTable.insert( 0x0011 );	// SDT/BAT
	this->m_wStaticPassTable.insert( 0x0012 );	// EIT
	this->m_wStaticPassTable.insert( 0x0026 );	// EIT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0027 );	// EIT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0013 );	// RST
	this->m_wStaticPassTable.insert( 0x0014 );	// TDT/TOT
	this->m_wStaticPassTable.insert( 0x0017 );	// DCT
	this->m_wStaticPassTable.insert( 0x001E );	// DIT
	this->m_wStaticPassTable.insert( 0x001F );	// SIT
	this->m_wStaticPassTable.insert( 0x0020 );	// LIT
	this->m_wStaticPassTable.insert( 0x0021 );	// ERT
	this->m_wStaticPassTable.insert( 0x0022 );	// PCAT
	this->m_wStaticPassTable.insert( 0x0023 );	// SDTT
	this->m_wStaticPassTable.insert( 0x0028 );	// SDTT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0024 );	// BIT
	this->m_wStaticPassTable.insert( 0x0025 );	// NBIT
	this->m_wStaticPassTable.insert( 0x0025 );	// LDT
	this->m_wStaticPassTable.insert( 0x0029 );	// CDT
	this->m_wStaticPassTable.insert( 0x002F );	// dt[wb_
//	this->m_wStaticPassTable.insert( 0x1FFF );	// kpPbg
#endif
}

CTs1segFilter::~CTs1segFilter()
{
}

const bool CTs1segFilter::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	CBlockLock Lock( &this->m_DecoderLock );

	CTsPacket* t_pcTsPacket = static_cast<CTsPacket *>(pMediaData);
	WORD t_wPid = t_pcTsPacket->GetPID();

#if USE_TSANALYZER
	// CTsAnalyzer::PID[eBO
	this->m_PidMapManager.StorePacket(t_pcTsPacket);

	WORD t_wNumber = this->GetServiceNum();
	for( int t_nIndex = 0 ; t_nIndex < t_wNumber ; t_nIndex++ )
	{
		WORD t_wPmtPid = 0x00;
		ServiceInfo t_stServiceInfo;
		if( this->GetServiceInfo( t_nIndex, &t_stServiceInfo ) && t_stServiceInfo.bIsUpdated )
		{
			if( t_stServiceInfo.PmtPID == 0x1fc8 )
			{
				std::vector<EsInfo>::iterator t_itEsInfo;

				// ʉ߂PMTXgAbv
				this->m_wDynamicPassTable.clear();
				
				// f
				this->m_wDynamicPassTable.insert( t_stServiceInfo.VideoEs.PID );

				// 
				for( t_itEsInfo = t_stServiceInfo.AudioEsList.begin() ; t_itEsInfo != t_stServiceInfo.AudioEsList.end() ; t_itEsInfo++ )
				{
					this->m_wDynamicPassTable.insert( ( *t_itEsInfo ).PID );
				}

				// H
				for( t_itEsInfo = t_stServiceInfo.CaptionEsList.begin() ; t_itEsInfo != t_stServiceInfo.CaptionEsList.end() ; t_itEsInfo++ )
				{
					this->m_wDynamicPassTable.insert( ( *t_itEsInfo ).PID );
				}

				// f[^H
				for( t_itEsInfo = t_stServiceInfo.DataCarrouselEsList.begin() ; t_itEsInfo != t_stServiceInfo.DataCarrouselEsList.end() ; t_itEsInfo++ )
				{
					this->m_wDynamicPassTable.insert( ( *t_itEsInfo ).PID );
				}

				this->m_wDynamicPassTable.insert( t_stServiceInfo.PmtPID );

//				this->m_wDynamicPassTable.insert( t_stServiceInfo.EcmPID );
				this->m_wDynamicPassTable.insert( t_stServiceInfo.PcrPID );
//				this->m_wDynamicPassTable.insert( t_stServiceInfo.LogoID );
				
				break;
			}
			t_stServiceInfo.bIsUpdated = false;
		}
	}
#else
	if( 0x1fc8 == t_wPid )	// ZOPMTT(dꂽԑgɂ͑ΉĂȂ)
//	if( ( 0x1fc8 <= t_wPid ) && ( t_wPid <= 0x1fcf ) )	// ZOPMTT
	{
		// ʉ߂PMTXgAbv
		this->m_wDynamicPassTable.clear();

		CTsPmtPacket t_cTsPmtPacket;

		t_cTsPmtPacket.StorePacket( t_pcTsPacket );
		
		INT32 t_nSize = static_cast< INT32 >( t_cTsPmtPacket.GetEsPidSize() );
		for( INT32 t_nIndex = 0 ; t_nIndex < t_nSize ; t_nIndex++ )
		{
			CTsPmtPacket::STPid& tr_stPid = t_cTsPmtPacket.GetEsPid( t_nIndex );
			this->m_wDynamicPassTable.insert( tr_stPid.m_wPid );
		}

		this->m_wDynamicPassTable.insert( t_cTsPmtPacket.GetPmtPid() );
		this->m_wDynamicPassTable.insert( t_cTsPmtPacket.GetPcrPid() );
	}
#endif

	// PMTɋLꂽPIDƁAɕKvȌŒPID𓧉߂
	if( ( this->m_wDynamicPassTable.find( t_wPid ) != this->m_wDynamicPassTable.end() )
#if USE_STATICPASS
	 || ( this->m_wStaticPassTable.find( t_wPid ) != this->m_wStaticPassTable.end() )
#else
	 || ( 0x0000 == t_wPid )								// PAT͒ʉ߂
	 || ( ( 0x0010 <= t_wPid ) && ( t_wPid <= 0x002F ) )	// ŒPID́A͈͂œĂĂ܂
#endif
	)
	{
		this->OutputMedia( t_pcTsPacket, dwInputIndex );
	}

	return true;
}

void CTs1segFilter::Reset()
{
	CBlockLock Lock(&m_DecoderLock);

#if USE_TSANALYZER
	CTsAnalyzer::Reset();
#endif
	this->m_wDynamicPassTable.clear();
}

#if !USE_TSANALYZER
CTsPmtPacket::CTsPmtPacket(void)
	: m_wPmtPid( 0 )
	, m_wPcrPid( 0 )
{
}

CTsPmtPacket::~CTsPmtPacket()
{
}

void CTsPmtPacket::StorePacket( CTsPacket* t_pcTsPacket )
{
	// wb_̉
	{
		BYTE* t_byteCurrent = t_pcTsPacket->GetData();

		// wb_
		t_byteCurrent += 1;

		// PMT PID
		this->m_wPmtPid = ( ( (WORD)t_byteCurrent[ 0 ] << 8 ) | (WORD)t_byteCurrent[ 1 ] ) & 0x1FFF;
		t_byteCurrent += 2;

	}

	// yC[h̉
	{
		BYTE* t_bytePayload = t_pcTsPacket->GetData() + 4;

		BYTE* t_byteCurrent = t_bytePayload;
		t_byteCurrent += 2;

		// ZNV擾
		WORD t_wSectionLength = ( ( (WORD)t_byteCurrent[ 0 ] << 8 ) | (WORD)t_byteCurrent[ 1 ] ) & 0x0FFF;
		t_byteCurrent += 2;

		// ԑgԍ
		t_byteCurrent += 2;

		// o[Wԍ/JglNXgw
		t_byteCurrent += 1;

		// ZbVԍ
		t_byteCurrent += 1;

		// ŏIZNVԍ
		t_byteCurrent += 1;


		// PCR PID
		this->m_wPcrPid = ( ( (WORD)t_byteCurrent[ 0 ] << 8 ) | (WORD)t_byteCurrent[ 1 ] ) & 0x1FFF;
		t_byteCurrent += 2;

		// ԑg񒷂擾
		WORD t_wPcrLength = ( ( (WORD)t_byteCurrent[ 0 ] << 8 ) | (WORD)t_byteCurrent[ 1 ] ) & 0x0FFF;
		t_byteCurrent += 2;

		// Lqq̈1
		t_byteCurrent += t_wPcrLength;

		BYTE* t_bytePayloadEnd = t_bytePayload + t_wSectionLength;
		while( t_byteCurrent < t_bytePayloadEnd )
		{
			STPid t_stPid;

			// Xg[`
			t_stPid.m_byteType = *t_byteCurrent;
			t_byteCurrent += 1;

			// PCR PID
			t_stPid.m_wPid = ( ( (WORD)t_byteCurrent[ 0 ] << 8 ) | (WORD)t_byteCurrent[ 1 ] ) & 0x1FFF;
			t_byteCurrent += 2;

			// ES񒷂擾
			WORD t_wEsInfoLength = ( ( (WORD)t_byteCurrent[ 0 ] << 8 ) | (WORD)t_byteCurrent[ 1 ] ) & 0x0FFF;
			t_byteCurrent += 2;

			// Lqq̈2
			t_byteCurrent += t_wEsInfoLength;

			this->m_stPids.push_back( t_stPid );
		}
	}
}

WORD CTsPmtPacket::GetPmtPid(void)
{
	return this->m_wPmtPid;
}

WORD CTsPmtPacket::GetPcrPid(void)
{
	return this->m_wPcrPid;
}

size_t CTsPmtPacket::GetEsPidSize(void)
{
	return this->m_stPids.size();
}

CTsPmtPacket::STPid& CTsPmtPacket::GetEsPid( INT32 t_nIndex )
{
	return this->m_stPids[ t_nIndex ];
}

#endif
